/*
 * Copyright 2012 Jeanfrancois Arcand
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.atmosphere.samples.scala.chat

import javax.ws.rs.{GET, POST, Path, Produces, Consumes}
import org.atmosphere.annotation.{Broadcast, Suspend}
import org.atmosphere.cpr.Broadcaster
import javax.ws.rs.core.Context

@Path("/")
class ScalaChat {

  @Suspend
  @Produces(Array("application/json"))
  @GET def suspend: String = {
    return ""
  }

  @Broadcast
  @Consumes(Array("application/json"))
  @POST def broadcast(@Context b: Broadcaster, message: Message): Unit = {
    b.broadcast(new Response(message.author, message.message))
  }
}